import{s as Te,n as Me,o as Le}from"../chunks/scheduler.25b97de1.js";import{S as Ce,i as He,g as a,s as n,r as k,A as Pe,h as s,f as i,c as o,j as _e,u as E,x as r,k as be,y as ke,a as l,v as W,d as I,t as j,w as q}from"../chunks/index.d9030fc9.js";import{H as z,E as Ee}from"../chunks/EditOnGithub.91d95064.js";function We(re){let m,S,A,U,d,D,f,me=`On of the long standing critic we have seen is also the core philosophy of transformers: <a href="https://huggingface.co/blog/transformers-design-philosophy" rel="nofollow"><code>single model, single file</code></a>.
For the past 4 years we were adamant on having no inheritance in <code>transformers</code>. The core motivation stems from our values and are the following:`,G,h,de=`<li>code readability: we want people to understand how a model works without being exposed to parameters or arguments that are related to <code>transformers</code> but not the model itself.
-&gt; we do not allow code paths
-&gt; we do not allow one liners
-&gt; we force meaningful variable names
-&gt; we do not allow inheriting from other models</li> <li>reproducibility: we want people to easily reproduce, debug and run models. For this, we want them to easily copy paste a modeling code and make it work (with deletion yes, but without having to add more code from other modules).</li> <li>education: as a lot of our code ends up being reused, we have a duty to write code that is educative and understandable to anyone that wants to understand how that code works.</li> <li>debugging: inheritance is particularly annoying when debugging, we made a moral choice to ease debugging experience, only having to go in the modeling.</li>`,O,u,fe="We introduces the <code>make fix-copies</code> along with the <code># Copied from</code> macros, which help re-using the code, but in the past 2 years we realized the limitation from it.",Y,p,B,c,he="It’s an alpha tool / feature that introduces a new <code>linter</code>. The linter converts a <code>modular</code> file to a <code>single model, single file</code>. The key idea is to allow people to add new models using inheritance, which will make identifying differences between models a lot easier, but keeping the single model single file policy.",R,g,ue="When you design your new model using modularity, you just need to think in the most pythonic way, the linter is just going to “flatten” or “unravel” 1 level of inheritance.",J,w,pe="The linter will convert the <code>modular_my_model.py</code> to the classic <code>modeling_my_model.py</code>, from which we will import everything as usual. But, <strong>importing from the modular file</strong> or <strong>importing from the modeling file</strong> should yield the same results!",K,$,ce="It is also a drop in replacement for our <code># Copied from</code> markers.",N,v,Q,y,ge="The “linter”, which unravels the inheritance and creates all single-files from the modular file, will flatten the inheritance while trying to be invisible to Python users. For example:",V,x,we="<li>If a configuration class inherits from another and adds/deletes an argument, the generated file will either directly reference it (in case of addition) or completely remove it (in case of deletion).</li> <li>If a class inherits from another, for example: class GemmaModel(LlamaModel):, dependencies are automatically inferred. All submodules will be automatically inferred from the superclass.</li>",X,_,$e="You should be able to write everything (the tokenizer, the image processor, the model, the config) in this <code>modular</code> file, and the corresponding files will be created for you.",Z,b,ee,T,ve="We are also introducing a new test, that makes sure the generated content matches what is present in the <code>modular_xxxx.py</code>",te,M,ie,L,ye="You can find a list of examples",le,C,ne,H,xe="It is not a replacement for the modeling code (yet?), and if your model is not based on anything else that ever existed, then you can add a <code>modeling</code> file as usual.",oe,P,ae,F,se;return d=new z({props:{title:"Modular transformers",local:"modular-transformers",headingTag:"h1"}}),p=new z({props:{title:"What is it?",local:"what-is-it",headingTag:"h2"}}),v=new z({props:{title:"Details",local:"details",headingTag:"h3"}}),b=new z({props:{title:"Enforcement",local:"enforcement",headingTag:"h3"}}),M=new z({props:{title:"Examples",local:"examples",headingTag:"h3"}}),C=new z({props:{title:"What it is not",local:"what-it-is-not",headingTag:"h2"}}),P=new Ee({props:{source:"https://github.com/huggingface/transformers/blob/main/docs/source/en/modular_transformers.md"}}),{c(){m=a("meta"),S=n(),A=a("p"),U=n(),k(d.$$.fragment),D=n(),f=a("p"),f.innerHTML=me,G=n(),h=a("ul"),h.innerHTML=de,O=n(),u=a("p"),u.innerHTML=fe,Y=n(),k(p.$$.fragment),B=n(),c=a("p"),c.innerHTML=he,R=n(),g=a("p"),g.textContent=ue,J=n(),w=a("p"),w.innerHTML=pe,K=n(),$=a("p"),$.innerHTML=ce,N=n(),k(v.$$.fragment),Q=n(),y=a("p"),y.textContent=ge,V=n(),x=a("ul"),x.innerHTML=we,X=n(),_=a("p"),_.innerHTML=$e,Z=n(),k(b.$$.fragment),ee=n(),T=a("p"),T.innerHTML=ve,te=n(),k(M.$$.fragment),ie=n(),L=a("p"),L.textContent=ye,le=n(),k(C.$$.fragment),ne=n(),H=a("p"),H.innerHTML=xe,oe=n(),k(P.$$.fragment),ae=n(),F=a("p"),this.h()},l(e){const t=Pe("svelte-u9bgzb",document.head);m=s(t,"META",{name:!0,content:!0}),t.forEach(i),S=o(e),A=s(e,"P",{}),_e(A).forEach(i),U=o(e),E(d.$$.fragment,e),D=o(e),f=s(e,"P",{"data-svelte-h":!0}),r(f)!=="svelte-yt9pap"&&(f.innerHTML=me),G=o(e),h=s(e,"UL",{"data-svelte-h":!0}),r(h)!=="svelte-qihz0g"&&(h.innerHTML=de),O=o(e),u=s(e,"P",{"data-svelte-h":!0}),r(u)!=="svelte-kfcoq7"&&(u.innerHTML=fe),Y=o(e),E(p.$$.fragment,e),B=o(e),c=s(e,"P",{"data-svelte-h":!0}),r(c)!=="svelte-1xs55bd"&&(c.innerHTML=he),R=o(e),g=s(e,"P",{"data-svelte-h":!0}),r(g)!=="svelte-1ta1l09"&&(g.textContent=ue),J=o(e),w=s(e,"P",{"data-svelte-h":!0}),r(w)!=="svelte-1w2gv6q"&&(w.innerHTML=pe),K=o(e),$=s(e,"P",{"data-svelte-h":!0}),r($)!=="svelte-1v3vb3"&&($.innerHTML=ce),N=o(e),E(v.$$.fragment,e),Q=o(e),y=s(e,"P",{"data-svelte-h":!0}),r(y)!=="svelte-etc71w"&&(y.textContent=ge),V=o(e),x=s(e,"UL",{"data-svelte-h":!0}),r(x)!=="svelte-1kme7ht"&&(x.innerHTML=we),X=o(e),_=s(e,"P",{"data-svelte-h":!0}),r(_)!=="svelte-1k7k1lb"&&(_.innerHTML=$e),Z=o(e),E(b.$$.fragment,e),ee=o(e),T=s(e,"P",{"data-svelte-h":!0}),r(T)!=="svelte-1egsha1"&&(T.innerHTML=ve),te=o(e),E(M.$$.fragment,e),ie=o(e),L=s(e,"P",{"data-svelte-h":!0}),r(L)!=="svelte-axp3n1"&&(L.textContent=ye),le=o(e),E(C.$$.fragment,e),ne=o(e),H=s(e,"P",{"data-svelte-h":!0}),r(H)!=="svelte-1cj74u8"&&(H.innerHTML=xe),oe=o(e),E(P.$$.fragment,e),ae=o(e),F=s(e,"P",{}),_e(F).forEach(i),this.h()},h(){be(m,"name","hf:doc:metadata"),be(m,"content",Ie)},m(e,t){ke(document.head,m),l(e,S,t),l(e,A,t),l(e,U,t),W(d,e,t),l(e,D,t),l(e,f,t),l(e,G,t),l(e,h,t),l(e,O,t),l(e,u,t),l(e,Y,t),W(p,e,t),l(e,B,t),l(e,c,t),l(e,R,t),l(e,g,t),l(e,J,t),l(e,w,t),l(e,K,t),l(e,$,t),l(e,N,t),W(v,e,t),l(e,Q,t),l(e,y,t),l(e,V,t),l(e,x,t),l(e,X,t),l(e,_,t),l(e,Z,t),W(b,e,t),l(e,ee,t),l(e,T,t),l(e,te,t),W(M,e,t),l(e,ie,t),l(e,L,t),l(e,le,t),W(C,e,t),l(e,ne,t),l(e,H,t),l(e,oe,t),W(P,e,t),l(e,ae,t),l(e,F,t),se=!0},p:Me,i(e){se||(I(d.$$.fragment,e),I(p.$$.fragment,e),I(v.$$.fragment,e),I(b.$$.fragment,e),I(M.$$.fragment,e),I(C.$$.fragment,e),I(P.$$.fragment,e),se=!0)},o(e){j(d.$$.fragment,e),j(p.$$.fragment,e),j(v.$$.fragment,e),j(b.$$.fragment,e),j(M.$$.fragment,e),j(C.$$.fragment,e),j(P.$$.fragment,e),se=!1},d(e){e&&(i(S),i(A),i(U),i(D),i(f),i(G),i(h),i(O),i(u),i(Y),i(B),i(c),i(R),i(g),i(J),i(w),i(K),i($),i(N),i(Q),i(y),i(V),i(x),i(X),i(_),i(Z),i(ee),i(T),i(te),i(ie),i(L),i(le),i(ne),i(H),i(oe),i(ae),i(F)),i(m),q(d,e),q(p,e),q(v,e),q(b,e),q(M,e),q(C,e),q(P,e)}}}const Ie='{"title":"Modular transformers","local":"modular-transformers","sections":[{"title":"What is it?","local":"what-is-it","sections":[{"title":"Details","local":"details","sections":[],"depth":3},{"title":"Enforcement","local":"enforcement","sections":[],"depth":3},{"title":"Examples","local":"examples","sections":[],"depth":3}],"depth":2},{"title":"What it is not","local":"what-it-is-not","sections":[],"depth":2}],"depth":1}';function je(re){return Le(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Fe extends Ce{constructor(m){super(),He(this,m,je,We,Te,{})}}export{Fe as component};
